package pack;

import java.util.Random;

public class Police {
    private int x, y;
    private static boolean see;

    Police(int x, int y) {
        this.x = x;
        this.y = y;
        see = false;
    }

    public void randomMove(int n, int m, PlayGround playGround) {
        boolean i, j, I, J;
        i = j = I = J = false;
        if (x != 0) i = true;
        if (x != n - 1) I = true;
        if (y != 0) j = true;
        if (y != m - 1) J = true;

        if (!i && !I && !j && !J) System.out.println("truuuuuuuuuuuuuuuuuue nistan // police -> random move");

        Random random = new Random();
        boolean confirm = false;
        int X = 0, Y = 0;

        System.out.println("x = "+x+" y = "+y+"\n i "+i+"\n I "+I+"\n j "+j+"\n J "+J);
        do {
            switch (random.nextInt(8)) {
                case 0:
                    if (i && j) {
                        X = x - 1;
                        Y = y - 1;
                        confirm = playGround.isEmpty(X, Y);
                    }
                    break;

                case 1:
                    if (i) {
                        X = x - 1;
                        Y = y;
                        confirm = playGround.isEmpty(X, Y);
                    }
                    break;

                case 2:
                    if (i && J) {
                        X = x - 1;
                        Y = y + 1;
                        confirm = playGround.isEmpty(X, Y);
                    }
                    break;

                case 3:
                    if (j) {
                        X = x;
                        Y = y - 1;
                        confirm = playGround.isEmpty(X, Y);
                    }
                    break;

                case 4:
                    if (J) {
                        X = x;
                        Y = y + 1;
                        confirm = playGround.isEmpty(X, Y);
                    }
                    break;

                case 5:
                    if (j && I) {
                        X = x + 1;
                        Y = y - 1;
                        confirm = playGround.isEmpty(X, Y);
                    }
                    break;

                case 6:
                    if (I) {
                        X = x + 1;
                        Y = y;
                        confirm = playGround.isEmpty(X, Y);
                    }
                    break;

                case 7:
                    if (I && J) {
                        X = x + 1;
                        Y = y + 1;
                        confirm = playGround.isEmpty(X, Y);
                    }
            }
        } while (!confirm);

        playGround.changeSituation(x, y, X, Y, 1);
        x = X;
        y = Y;
        

    }

    public void targetedMove(int[][] thiefSituation, PlayGround playGround) {
        int X = thiefSituation[0][0], Y = thiefSituation[0][1];
        int[][] newSituation;

        int c = 0;
        for (int j, z = 0; z < playGround.getNM()[0][0]; z++)
            for (j = 0; j < playGround.getNM()[0][1]; j++)
                if (playGround.getGround()[z][j] == 1)
                    c++;
        System.out.println("\nc1 ============== " + c);

        if (x > X) {
            if (y > Y)         // down, right
                newSituation = confirmTargetMove(x, y, 1, playGround);
            else if (y < Y)  // down, left
                newSituation = confirmTargetMove(x, y, 3, playGround);
            else             // down
                newSituation = confirmTargetMove(x, y, 2, playGround);
        } else if (x < X) {
            if (y > Y)        // up, right
                newSituation = confirmTargetMove(x, y, 6, playGround);
            else if (y < Y)  // up, left
                newSituation = confirmTargetMove(x, y, 8, playGround);
            else             // up
                newSituation = confirmTargetMove(x, y, 7, playGround);
        } else {
            if (y < Y)         // left
                newSituation = confirmTargetMove(x, y, 5, playGround);
            else             // right
                newSituation = confirmTargetMove(x, y, 4, playGround);

        }

        c = 0;
        for (int j, z = 0; z < playGround.getNM()[0][0]; z++)
            for (j = 0; j < playGround.getNM()[0][1]; j++)
                if (playGround.getGround()[z][j] == 1)
                    c++;
        System.out.println("c1.5 ============ " + c);


        playGround.changeSituation(x, y, newSituation[0][0], newSituation[0][1], 1);
        x = newSituation[0][0];
        y = newSituation[0][1];

        c = 0;
        for (int j, z = 0; z < playGround.getNM()[0][0]; z++)
            for (j = 0; j < playGround.getNM()[0][1]; j++)
                if (playGround.getGround()[z][j] == 1)
                    c++;
        System.out.println("c2 ============== " + c + "\n");

    }

    public void targetedMove2(int[][] thiefSituation, PlayGround playGround) {
        int X = thiefSituation[0][0], Y = thiefSituation[0][1];
        int[][] newSituation = new int[1][2];

        switch ((int) (1000 * (Math.sqrt(Math.pow(X - x, 2) + Math.pow(Y - y, 2)) - Math.sqrt(Math.pow(X - 0.3 - x, 2) + Math.pow(Y - 0.4 - getY(), 2))))) {
            case 493:                                    // up, left
            case 433:
            case 489:
            case 492:
                newSituation = confirmTargetMove(x, y, 8, playGround);
                break;

            case 193:       // up
            case 253:
                newSituation = confirmTargetMove(x, y, 7, playGround);
                break;

            case 33:
            case -112:
            case -151:
            case -263:      //up, right
                newSituation = confirmTargetMove(x, y, 6, playGround);
                break;

            case 372:
            case 329:       //left
                newSituation = confirmTargetMove(x, y, 5, playGround);
                break;

            case -431:
            case -418:      //right
                newSituation = confirmTargetMove(x, y, 4, playGround);
                break;

            case 174:
            case -17:
            case -140:
            case 26:        //down, left
                newSituation = confirmTargetMove(x, y, 3, playGround);
                break;

            case -360:
            case -334:       //down
                newSituation = confirmTargetMove(x, y, 2, playGround);
                break;

            case -496:
            case -493:
            case -456:
            case -495:      //down, right
                newSituation = confirmTargetMove(x, y, 1, playGround);

        }


        if (newSituation[0][0] != x || newSituation[0][1] != y)
            playGround.changeSituation(x, y, newSituation[0][0], newSituation[0][1], 1);

    }

    public int[][] confirmTargetMove(int x, int y, int destination, PlayGround p) {
        int[][] newSituation = new int[1][2];
        Random r = new Random();

        switch (destination) {
            case 1:
                if (p.isEmpty(x - 1, y - 1)) {                 // go up & left
                    newSituation[0][0] = x - 1;
                    newSituation[0][1] = y - 1;
                    return newSituation;
                } else {
                    switch (r.nextInt(2)) {
                        case 0:
                            if (p.isEmpty(x - 1, y)) {            // go up
                                newSituation[0][0] = x - 1;
                                newSituation[0][1] = y;
                                return newSituation;
                            }
                        case 1:
                            if (p.isEmpty(x, y - 1)) {            // go left
                                newSituation[0][0] = x;
                                newSituation[0][1] = y - 1;
                                return newSituation;
                            }
                    }
                    newSituation[0][0] = x;                          // stay in previous situation
                    newSituation[0][1] = y;
                    return newSituation;
                }

            case 2:
                if (p.isEmpty(x - 1, y)) {                        // go up
                    newSituation[0][0] = x - 1;
                    newSituation[0][1] = y;
                    return newSituation;
                } else {
                    switch (r.nextInt(2)) {
                        case 0:
                            if (y != p.getNM()[0][1] - 1 && p.isEmpty(x - 1, y + 1)) {     // go up, right
                                newSituation[0][0] = x - 1;
                                newSituation[0][1] = y + 1;
                                return newSituation;
                            }
                        case 1:
                            if (y != 0 && p.isEmpty(x - 1, y - 1)) {     // go up, left
                                newSituation[0][0] = x - 1;
                                newSituation[0][1] = y - 1;
                                return newSituation;
                            }
                    }
                    newSituation[0][0] = x;                          // stay in previous situation
                    newSituation[0][1] = y;
                    return newSituation;
                }

            case 3:
                if (p.isEmpty(x - 1, y + 1)) {                 // go up & right
                    newSituation[0][0] = x - 1;
                    newSituation[0][1] = y + 1;
                    return newSituation;
                } else {
                    switch (r.nextInt(2)) {
                        case 0:
                            if (p.isEmpty(x, y + 1)) {             // go right
                                newSituation[0][0] = x;
                                newSituation[0][1] = y + 1;
                                return newSituation;
                            }
                        case 1:
                            if (p.isEmpty(x - 1, y)) {              // go up
                                newSituation[0][0] = x - 1;
                                newSituation[0][1] = y;
                                return newSituation;
                            }
                    }
                    newSituation[0][0] = x;                          // stay in previous situation
                    newSituation[0][1] = y;
                    return newSituation;
                }

            case 4:
                if (p.isEmpty(x, y - 1)) {                        // go left
                    newSituation[0][0] = x;
                    newSituation[0][1] = y - 1;
                    return newSituation;
                } else {
                    switch (r.nextInt(2)) {
                        case 0:
                            if (x != 0 && p.isEmpty(x - 1, y - 1)) {     // go up , left
                                newSituation[0][0] = x - 1;
                                newSituation[0][1] = y - 1;
                                return newSituation;
                            }
                        case 1:
                            if (x != p.getNM()[0][0] && p.isEmpty(x + 1, y - 1)) {     // go down, left
                                newSituation[0][0] = x + 1;
                                newSituation[0][1] = y - 1;
                                return newSituation;
                            }
                    }
                    newSituation[0][0] = x;                          // stay in previous situation
                    newSituation[0][1] = y;
                    return newSituation;
                }

            case 5:
                if (p.isEmpty(x, y + 1)) {                        // go right
                    newSituation[0][0] = x;
                    newSituation[0][1] = y + 1;
                    return newSituation;
                } else {
                    switch (r.nextInt(2)) {
                        case 0:
                            if (x != p.getNM()[0][0] && p.isEmpty(x + 1, y + 1)) {     // go down, right
                                newSituation[0][0] = x + 1;
                                newSituation[0][1] = y + 1;
                                return newSituation;
                            }
                        case 1:
                            if (x != 0 && p.isEmpty(x - 1, y + 1)) {     // go up, right
                                newSituation[0][0] = x - 1;
                                newSituation[0][1] = y + 1;
                                return newSituation;
                            }
                    }
                    newSituation[0][0] = x;                          // stay in previous situation
                    newSituation[0][1] = y;
                    return newSituation;
                }

            case 6:
                if (p.isEmpty(x + 1, y - 1)) {                 // go down & left
                    newSituation[0][0] = x + 1;
                    newSituation[0][1] = y - 1;
                    return newSituation;
                } else {
                    switch (r.nextInt(2)) {
                        case 0:
                            if (p.isEmpty(x, y - 1)) {            // go left
                                newSituation[0][0] = x;
                                newSituation[0][1] = y - 1;
                                return newSituation;
                            }
                        case 1:
                            if (p.isEmpty(x + 1, y)) {            // go down
                                newSituation[0][0] = x - 1;
                                newSituation[0][1] = y;
                                return newSituation;
                            }
                    }
                    newSituation[0][0] = x;                          // stay in previous situation
                    newSituation[0][1] = y;
                    return newSituation;
                }

            case 7:
                if (p.isEmpty(x + 1, y)) {                        // go down
                    newSituation[0][0] = x + 1;
                    newSituation[0][1] = y;
                    return newSituation;
                } else {
                    switch (r.nextInt(2)) {
                        case 0:
                            if (y != 0 && p.isEmpty(x + 1, y - 1)) {     // go down, left
                                newSituation[0][0] = x + 1;
                                newSituation[0][1] = y - 1;
                                return newSituation;
                            }
                        case 1:
                            if (y != p.getNM()[0][1] && p.isEmpty(x + 1, y + 1)) {     // go down, right
                                newSituation[0][0] = x + 1;
                                newSituation[0][1] = y + 1;
                                return newSituation;
                            }
                    }
                    newSituation[0][0] = x;                          // stay in previous situation
                    newSituation[0][1] = y;
                    return newSituation;
                }

            case 8:
                if (p.isEmpty(x + 1, y + 1)) {          // go down, right
                    newSituation[0][0] = x + 1;
                    newSituation[0][1] = y + 1;
                    return newSituation;
                } else {
                    switch (r.nextInt(2)) {
                        case 0:
                            if (p.isEmpty(x + 1, y)) {            // go down
                                newSituation[0][0] = x + 1;
                                newSituation[0][1] = y;
                                return newSituation;
                            }
                        case 1:
                            if (p.isEmpty(x, y + 1)) {             // go right
                                newSituation[0][0] = x;
                                newSituation[0][1] = y + 1;
                                return newSituation;
                            }
                    }
                    newSituation[0][0] = x;                          // stay in previous situation
                    newSituation[0][1] = y;
                    return newSituation;
                }

        }
        return newSituation;
    }

    public int[][] getSituation() {
        int[][] Return = new int[1][1];
        Return[0][0] = x;
        Return[0][1] = y;
        return Return;
    }

    public int getX() {
        return x;
    }

    public int getY() {
        return y;
    }

}